require "block"

player = {}

function player.load()
	block.load()
	player.x = 5
	player.y = 5
	player.xvel = 0
	player.yvel = 0
	player.friction = 7
	player.speed = 2250
	player.width = 50
	player.height = 50
	player.groundposition = true
	player.jump = false 
	pulinho = 0

end

function player.draw()
	love.graphics.setColor(0, 135, 145)
	love.graphics.rectangle("fill", player.x, player.y, player.width, player.height)

end

function player.physics(dt)
	player.x = player.x + player.xvel * dt
	player.y = player.y + player.yvel * dt
	player.xvel = player.xvel * (1 - math.min(dt*player.friction, 1))
	if player.jump == true then
		player.y = player.y - 4
		pulinho = pulinho + 4
	end
	if pulinho >= 200 then 
		player.jump =  false
		pulinho = 0
	end
	if player.x + player.width > block.x and player.x < block.x+ block.width then
		if player.y + player.height > block.y and player.jump == false then -- faz bater do lado direito
			player.x = block.x - player.width
		elseif player.y < block.y + block.height and player.jump == true then
			player.x = block.x 
	    elseif player.x +player.width > block.x then
			player.y= block.y - block.height 
		else	
			player.x = block.x +block.width
		end
	end
end

function player.move(dt)
	if love.keyboard.isDown("d", "D", "istouch") and player.xvel < player.speed then
	   player.xvel = player.xvel + player.speed*dt
	end
    if love.keyboard.isDown("a", "A", "istouch") and player.xvel > -player.speed then 
    	player.xvel = player.xvel - player.speed * dt
    end
    if love.keyboard.isDown("w", "W", "istouch") and player.groundposition == true then
       player.jump = true
    end
    if player.y + player.height > groundlevel  then 
    	player.y = groundlevel - player.height
    	player.yvel = 0
    end

    player.y = player.y + dt*300	--gravidade

    if player.y + player.height < groundlevel then -- chão 
    	player.groundposition = false 
    elseif player.y + player.height >= groundlevel then
    	player.groundposition = true
    end
end

function player.boundary() -- laterais da janela
	if player.x < 0 then
		player.x = 0
		player.xvel = 0
	end
	if player.x > 1303 - player.width then
		player.x = 1303 - player.width
		player.xvel = 0
	end
end

function UPDATE_PLAYER(dt)
	player.physics(dt)
    player.move(dt)
    player.boundary()
end

function DRAW_PLAYER()
	player.draw()
	love.graphics.setColor(255, 0, 0)
	love.graphics.print("Find the game!", 600, 80, 0, 2)
end